// Copyright (C) 2023, Jakob Wakeling
// All rights reserved.

#include "log.h"

#include <errno.h>
#include <stdlib.h>
#include <string.h>

void *_xmalloc(size_t size, const char *file, int line) {
	void *p = malloc(size); if (!p) { log_abort("%s:%d: %s", file, line, strerror(errno)); } return p;
}

void *_xcalloc(size_t nmemb, size_t size, const char *file, int line) {
	void *p = calloc(nmemb, size); if (!p) { log_abort("%s:%d: %s", file, line, strerror(errno)); } return p;
}

void *_xrealloc(void *ptr, size_t size, const char *file, int line) {
	void *p = realloc(ptr, size); if (!p) { log_abort("%s:%d: %s", file, line, strerror(errno)); } return p;
}
